VERSION 5.00
Begin VB.Form DilelectricTest 
   Appearance      =   0  'Flat
   BackColor       =   &H80000004&
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Dielectric Test"
   ClientHeight    =   5010
   ClientLeft      =   420
   ClientTop       =   1650
   ClientWidth     =   9225
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Icon            =   "DielectricTest.frx":0000
   LinkMode        =   1  'Source
   LinkTopic       =   "Form3"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   5010
   ScaleWidth      =   9225
   StartUpPosition =   2  'CenterScreen
   Begin VB.CheckBox ChkProgStarted 
      Caption         =   "Check1"
      Height          =   255
      Left            =   240
      TabIndex        =   38
      Top             =   5520
      Width           =   255
   End
   Begin VB.CheckBox chkCardInstalled 
      Alignment       =   1  'Right Justify
      Caption         =   "Card Installed"
      Height          =   255
      Left            =   240
      TabIndex        =   35
      ToolTipText     =   "Enables running of software for test without IEEE card installed"
      Top             =   0
      Width           =   1695
   End
   Begin VB.TextBox txtCommand 
      DataField       =   "CommandDetail1"
      DataSource      =   "datCommands"
      Height          =   285
      Index           =   1
      Left            =   1560
      MaxLength       =   100
      TabIndex        =   33
      ToolTipText     =   "Command Line 2 to load"
      Top             =   3720
      Width           =   7455
   End
   Begin VB.CommandButton cmdEnterPassword 
      Caption         =   "Enter Password"
      Height          =   255
      Left            =   960
      TabIndex        =   32
      Top             =   5520
      Width           =   2415
   End
   Begin VB.Data datCommandsChk 
      Caption         =   "TestsChk"
      Connect         =   "Access"
      DatabaseName    =   "Commands.mdb"
      DefaultCursorType=   0  'DefaultCursor
      DefaultType     =   2  'UseODBC
      Exclusive       =   0   'False
      Height          =   375
      Left            =   5880
      Options         =   0
      ReadOnly        =   0   'False
      RecordsetType   =   0  'Table
      RecordSource    =   "Commands"
      Top             =   5520
      Width           =   2175
   End
   Begin VB.TextBox txtTestInstructions 
      DataField       =   "Instructions"
      DataSource      =   "datCommands"
      Height          =   735
      Left            =   1560
      MaxLength       =   200
      MultiLine       =   -1  'True
      TabIndex        =   31
      ToolTipText     =   "Instructions for Test Procedure"
      Top             =   4080
      Width           =   7455
   End
   Begin VB.TextBox txtPasswordEntry 
      Height          =   285
      IMEMode         =   3  'DISABLE
      Left            =   4800
      PasswordChar    =   "*"
      TabIndex        =   28
      ToolTipText     =   "Set password for Programmer"
      Top             =   2520
      Visible         =   0   'False
      Width           =   1215
   End
   Begin VB.TextBox txtPassword 
      Height          =   285
      IMEMode         =   3  'DISABLE
      Left            =   4800
      PasswordChar    =   "*"
      TabIndex        =   27
      Top             =   2520
      Visible         =   0   'False
      Width           =   1215
   End
   Begin VB.CommandButton cmdChangePassword 
      Caption         =   "Change Password"
      Height          =   375
      Left            =   6720
      TabIndex        =   26
      ToolTipText     =   "Change Programmer Password"
      Top             =   2880
      Width           =   1935
   End
   Begin VB.CommandButton cmdOperatorProgrammer 
      Caption         =   "Programmer"
      Height          =   375
      Left            =   240
      TabIndex        =   25
      ToolTipText     =   "Select Programmer or User Mode initial password = password"
      Top             =   1560
      Width           =   1215
   End
   Begin VB.TextBox txtTestId 
      DataField       =   "CmdID"
      DataSource      =   "datCommands"
      Enabled         =   0   'False
      Height          =   285
      Left            =   1560
      MaxLength       =   50
      TabIndex        =   23
      ToolTipText     =   "Test ID"
      Top             =   3000
      Width           =   4455
   End
   Begin VB.Data datCommands 
      Caption         =   "Tests"
      Connect         =   "Access"
      DatabaseName    =   "Commands.mdb"
      DefaultCursorType=   0  'DefaultCursor
      DefaultType     =   2  'UseODBC
      Exclusive       =   0   'False
      Height          =   375
      Left            =   3600
      Options         =   0
      ReadOnly        =   0   'False
      RecordsetType   =   0  'Table
      RecordSource    =   "Commands"
      Top             =   5520
      Width           =   1935
   End
   Begin VB.ListBox lstTestIDs 
      Height          =   2010
      Left            =   6240
      Sorted          =   -1  'True
      TabIndex        =   21
      ToolTipText     =   "Existing Tests Id's to select"
      Top             =   240
      Width           =   2775
   End
   Begin VB.CommandButton cmdDelete 
      Caption         =   "Delete"
      Height          =   375
      Left            =   7800
      TabIndex        =   20
      ToolTipText     =   "Delete Existing Record"
      Top             =   2400
      Width           =   1095
   End
   Begin VB.CommandButton cmdAddFind 
      Caption         =   "Add/Find"
      Height          =   375
      Left            =   6480
      TabIndex        =   19
      ToolTipText     =   "Add new test record or find an existing one"
      Top             =   2400
      Width           =   1095
   End
   Begin VB.CommandButton cmdLoadTest 
      Caption         =   "Load Test"
      Height          =   375
      Left            =   4800
      TabIndex        =   18
      ToolTipText     =   "Load Command Line data via selected interface"
      Top             =   1560
      Width           =   1215
   End
   Begin VB.TextBox txtCommand 
      DataField       =   "CommandDetail0"
      DataSource      =   "datCommands"
      Height          =   285
      Index           =   0
      Left            =   1560
      MaxLength       =   100
      TabIndex        =   16
      ToolTipText     =   "Command Line 1 to load"
      Top             =   3360
      Width           =   7455
   End
   Begin VB.TextBox txtPA3 
      Height          =   285
      Left            =   4080
      MaxLength       =   1
      TabIndex        =   15
      ToolTipText     =   "Primary Address of Device"
      Top             =   2520
      Width           =   255
   End
   Begin VB.TextBox txtPA2 
      Height          =   285
      Left            =   3000
      MaxLength       =   1
      TabIndex        =   14
      ToolTipText     =   "Primary Address of Device"
      Top             =   2520
      Width           =   255
   End
   Begin VB.TextBox txtPA1 
      Height          =   285
      Left            =   1920
      MaxLength       =   1
      TabIndex        =   13
      ToolTipText     =   "Primary Address of Device"
      Top             =   2520
      Width           =   255
   End
   Begin VB.TextBox txtBI3 
      Height          =   285
      Left            =   4080
      MaxLength       =   1
      TabIndex        =   12
      ToolTipText     =   "Board Index"
      Top             =   2160
      Width           =   255
   End
   Begin VB.TextBox txtBI2 
      Height          =   285
      Left            =   3000
      MaxLength       =   1
      TabIndex        =   11
      ToolTipText     =   "Board Index"
      Top             =   2160
      Width           =   255
   End
   Begin VB.TextBox txtBI1 
      Height          =   285
      Left            =   1920
      MaxLength       =   1
      TabIndex        =   10
      ToolTipText     =   "Board Index"
      Top             =   2160
      Width           =   255
   End
   Begin VB.CheckBox ChkInt3 
      Caption         =   "Check3"
      Height          =   255
      Left            =   4080
      TabIndex        =   4
      ToolTipText     =   "Select Interface to load Command line data"
      Top             =   1800
      Width           =   255
   End
   Begin VB.CheckBox ChkInt2 
      Caption         =   "Check2"
      Height          =   255
      Left            =   3000
      TabIndex        =   3
      ToolTipText     =   "Select Interface to load Command line data"
      Top             =   1800
      Width           =   255
   End
   Begin VB.CheckBox ChkInt1 
      BackColor       =   &H8000000A&
      Caption         =   "Check1"
      ForeColor       =   &H8000000E&
      Height          =   255
      Left            =   1920
      TabIndex        =   2
      ToolTipText     =   "Select Interface to load Command line data"
      Top             =   1800
      Value           =   1  'Checked
      Width           =   255
   End
   Begin VB.ListBox ReadingsList 
      Appearance      =   0  'Flat
      BackColor       =   &H00FFFFFF&
      ForeColor       =   &H00000000&
      Height          =   1200
      Left            =   240
      TabIndex        =   0
      ToolTipText     =   "Displays Command lines as loaded"
      Top             =   240
      Width           =   5775
   End
   Begin VB.Label About 
      BackColor       =   &H8000000A&
      Caption         =   "About"
      ForeColor       =   &H00FFFFFF&
      Height          =   255
      Left            =   720
      TabIndex        =   37
      Top             =   4680
      Width           =   495
   End
   Begin VB.Label Help 
      BackColor       =   &H8000000A&
      Caption         =   "Help"
      ForeColor       =   &H00FFFFFF&
      Height          =   255
      Left            =   120
      TabIndex        =   36
      Top             =   4680
      Width           =   495
   End
   Begin VB.Label Label11 
      Alignment       =   2  'Center
      Caption         =   "Command Line 2"
      Height          =   255
      Left            =   120
      TabIndex        =   34
      Top             =   3720
      Width           =   1455
   End
   Begin VB.Label Label10 
      Alignment       =   2  'Center
      Caption         =   "Test Instructions"
      Height          =   375
      Left            =   240
      TabIndex        =   30
      Top             =   4200
      Width           =   1335
   End
   Begin VB.Label Label9 
      Alignment       =   2  'Center
      Caption         =   "Please Enter Password"
      Height          =   495
      Left            =   4680
      TabIndex        =   29
      Top             =   2040
      Visible         =   0   'False
      Width           =   1455
   End
   Begin VB.Label Label8 
      Alignment       =   2  'Center
      Caption         =   "Test ID"
      Height          =   255
      Left            =   240
      TabIndex        =   24
      Top             =   3000
      Width           =   1335
   End
   Begin VB.Label Label7 
      Caption         =   "Test ID's"
      Height          =   255
      Left            =   6240
      TabIndex        =   22
      Top             =   0
      Width           =   975
   End
   Begin VB.Label Label6 
      Alignment       =   2  'Center
      Caption         =   "Command Line 1"
      Height          =   255
      Left            =   120
      TabIndex        =   17
      Top             =   3360
      Width           =   1455
   End
   Begin VB.Label Label5 
      Alignment       =   2  'Center
      Caption         =   "Primary Address of Device"
      Height          =   495
      Left            =   240
      TabIndex        =   9
      Top             =   2520
      Width           =   1455
   End
   Begin VB.Label Label4 
      Alignment       =   2  'Center
      Caption         =   "Board Index"
      Height          =   255
      Left            =   240
      TabIndex        =   8
      Top             =   2160
      Width           =   1575
   End
   Begin VB.Label Label3 
      Caption         =   "Interface 3"
      Height          =   255
      Left            =   3720
      TabIndex        =   7
      Top             =   1560
      Width           =   1095
   End
   Begin VB.Label Label2 
      Caption         =   "Interface 2"
      Height          =   255
      Left            =   2640
      TabIndex        =   6
      Top             =   1560
      Width           =   1095
   End
   Begin VB.Label Label1 
      Caption         =   "Interface 1"
      Height          =   255
      Left            =   1560
      TabIndex        =   5
      Top             =   1560
      Width           =   1095
   End
   Begin VB.Label Readings 
      Alignment       =   2  'Center
      BackColor       =   &H00808080&
      BackStyle       =   0  'Transparent
      Caption         =   "Actions"
      ForeColor       =   &H00000000&
      Height          =   255
      Left            =   240
      TabIndex        =   1
      Top             =   0
      Width           =   5775
   End
End
Attribute VB_Name = "DilelectricTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim Dev As Integer

Private Sub About_Click()
  Message$ = ""
  AboutTitle$ = ""
  eol = Chr(10) & Chr(13)
  Open "DielectricTest.vbp" For Input As #2
  Do While Not EOF(2)
    Line Input #2, ThisLine$
    If InStr(ThisLine$, "Title") > 0 Then
      AboutTitle$ = "This Software " & ThisLine$
    End If
    If InStr(ThisLine$, "VersionComments") > 0 Then
      Message$ = Message$ & ThisLine$ & eol
    End If
    If InStr(ThisLine$, "VersionCompanyName") > 0 Then
      Message$ = Message$ & ThisLine$ & eol
    End If
    If InStr(ThisLine$, "MajorVer") > 0 Then
      Message$ = Message$ & ThisLine$ & eol
    End If
    If InStr(ThisLine$, "MinorVer") > 0 Then
      Message$ = Message$ & ThisLine$ & eol
    End If
    If InStr(ThisLine$, "RevisionVer") > 0 Then
      Message$ = Message$ & ThisLine$ & eol
    End If
    If InStr(ThisLine$, "VersionDescription") > 0 Then
      Message$ = Message$ & ThisLine$ & eol
    End If
    If InStr(ThisLine$, "VersionLegalCopyright") > 0 Then
      Message$ = Message$ & ThisLine$ & eol
    End If
    If InStr(ThisLine$, "VersionLegalTrademarks") > 0 Then
      Message$ = Message$ & ThisLine$ & eol
    End If
    If InStr(ThisLine$, "VersionProductName") > 0 Then
      Message$ = Message$ & ThisLine$ & eol
    End If
    If InStr(ThisLine$, "VersionFileDescription") > 0 Then
      Message$ = Message$ & ThisLine$ & eol
    End If
  Loop
  Close #2
  Prompt$ = ""
  reply = MsgBox(Message$, vbOKOnly, AboutTitle$)
End Sub

Private Sub chkCardInstalled_Validate(KeepFocus As Boolean)
  WriteParams
End Sub

Private Sub cmdAddFind_Click()
  Prompt$ = "Please Enter Test Reference to Add or Find."
  SearchStr$ = InputBox(Prompt$, "Test Reference Add/Find")
  If SearchStr$ <> "" Then
    datCommandsChk.Recordset.Index = "CmdID"
    datCommandsChk.Recordset.Seek "=", SearchStr$
    If datCommandsChk.Recordset.NoMatch Then
      response = MsgBox("Add New Record ?", vbYesNo, "Add New Record Yes/No")
      If Not response = vbYes Then
        Exit Sub
      End If
      datCommands.Recordset.AddNew
      txtTestId.Text = SearchStr$
      datCommands.Recordset.Index = "CmdID"
      datCommands.Recordset.Seek "=", SearchStr$
      MakeList
      datCommands.Recordset.Index = "CmdID"
      datCommands.Recordset.Seek "=", SearchStr$
      Exit Sub
    End If
    datCommands.Recordset.Index = "CmdID"
    datCommands.Recordset.Seek "=", SearchStr$
  End If
End Sub


Private Sub cmdChangePassword_Click()
  If txtPasswordEntry.Text <> txtPassword.Text Then
    txtPassword.Visible = True
    Label9.Visible = True
    txtPassword.SetFocus
    cmdEnterPassword.Default = True
    Exit Sub
  End If
End Sub

Private Sub cmdClick_Click()
  If txtPasswordEntry.Text <> txtPassword.Text Then
    txtPasswordEntry.Visible = False
    Label9.Visible = False
    Exit Sub
  End If
  txtPasswordEntry.Visible = False
  Label9.Visible = False
  cmdOperatorProgrammer.Caption = "Programmer"
  cmdAddFind.Visible = True
  cmdDelete.Visible = True
  cmdChangePassword.Visible = True
  txtBI1.Enabled = True
  txtBI2.Enabled = True
  txtBI3.Enabled = True
  txtPA1.Enabled = True
  txtPA2.Enabled = True
  txtPA3.Enabled = True
  txtCommand(0).Enabled = True
  txtCommand(1).Enabled = True
  txtTestInstructions.Locked = False
  lstTestIDs.Height = 2010
  txtPasswordEntry.Text = ""
  Exit Sub
End Sub

Private Sub cmdDelete_Click()
  If txtTestId.Text <> "" Then
    Prompt$ = "Do you really want to Delete this Record"
    reply = MsgBox(Prompt$, vbOKCancel, "Delete Record")
    If reply = vbOK Then
      SearchStr$ = txtTestId.Text
      datCommands.Recordset.Index = "CmdID"
      datCommands.Recordset.Seek "=", SearchStr$
      datCommands.Recordset.Delete
      MakeList
      datCommands.Recordset.MoveFirst
    End If
  End If
End Sub

Private Sub cmdEnterPassword_Click()
  If txtPasswordEntry.Text <> "" Then
    If txtPasswordEntry.Text <> txtPassword.Text Then
      txtPasswordEntry.Visible = False
      Label9.Visible = False
      cmdEnterPassword.Default = False
      txtPasswordEntry.Text = ""
      Exit Sub
    End If
    txtPasswordEntry.Visible = False
    Label9.Visible = False
    cmdOperatorProgrammer.Caption = "Programmer"
    cmdAddFind.Visible = True
    cmdDelete.Visible = True
    cmdChangePassword.Visible = True
    txtBI1.Enabled = True
    txtBI2.Enabled = True
    txtBI3.Enabled = True
    txtPA1.Enabled = True
    txtPA2.Enabled = True
    txtPA3.Enabled = True
    txtCommand(0).Enabled = True
    txtCommand(1).Enabled = True
    txtTestInstructions.Locked = False
    lstTestIDs.Height = 2010
    txtPasswordEntry.Text = ""
    cmdEnterPassword.Default = False
    Exit Sub
  End If
  If txtPasswordEntry.Text <> txtPassword.Text Then
    txtPassword.Visible = False
    Label9.Visible = False
    WriteParams
    cmdEnterPassword.Default = False
    Exit Sub
  End If
  cmdEnterPassword.Default = False
End Sub

Private Sub cmdLoadTest_Click()
  Dim DisplayStr As String
  If ChkInt1 <> 1 Then
    If ChkInt2 <> 1 Then
      If ChkInt3 <> 1 Then
        MsgBox "Error No Interface set.", vbOKOnly + vbExclamation, "Error"
        Exit Sub
      End If
    End If
  End If
  If ChkInt1 = 1 Then
    ReadingsList.AddItem ("         " & txtCommand(1).Text), 0
    ReadingsList.AddItem ("         " & txtCommand(0).Text), 0
    ReadingsList.AddItem ("Input: Interface 1 " & txtTestId.Text & " " & Time()), 0
    BDINDEX = Val(txtBI1.Text)
    PRIMARY_ADDR_OF_DEV = Val(txtPA1.Text)
  End If
  If ChkInt2 = 1 Then
    ReadingsList.AddItem ("         " & txtCommand(1).Text), 0
    ReadingsList.AddItem ("         " & txtCommand(0).Text), 0
    ReadingsList.AddItem ("Input: Interface 2 " & txtTestId.Text & " " & Time()), 0
    BDINDEX = Val(txtBI2.Text)
    PRIMARY_ADDR_OF_DEV = Val(txtPA2.Text)
  End If
  If ChkInt3 = 1 Then
    ReadingsList.AddItem ("         " & txtCommand(1).Text), 0
    ReadingsList.AddItem ("         " & txtCommand(0).Text), 0
    ReadingsList.AddItem ("Input: Interface 3 " & txtTestId.Text & " " & Time()), 0
    BDINDEX = Val(txtBI3.Text)
    PRIMARY_ADDR_OF_DEV = Val(txtPA3.Text)
  End If
  If chkCardInstalled.value = 0 Then
    Exit Sub
  End If
  SendIFC BDINDEX
'Exit Sub
  If (ibsta And EERR) Then
    GpibErr ("Error SendIFC.")
  End If
  For n = 0 To 1
    wrtbuf$ = txtCommand(n).Text
    Send BDINDEX, PRIMARY_ADDR_OF_DEV, wrtbuf$, NLend
    If (ibsta And EERR) Then
      GpibErr ("Error Sending Command Line.")
    End If
  Next n
End Sub
Private Sub MakeList()
  lstTestIDs.Clear
  datCommands.Refresh
  datCommands.Recordset.MoveFirst
  Do While Not datCommands.Recordset.EOF
    lstTestIDs.AddItem (txtTestId.Text)
    datCommands.Recordset.MoveNext
    Index = Index + 1
  Loop
  Index = Index + 1
  datCommands.Refresh
End Sub


Private Sub cmdOperatorProgrammer_Click()
  If cmdOperatorProgrammer.Caption = "Operator" Then
    txtPasswordEntry.Visible = True
    Label9.Visible = True
    txtPasswordEntry.SetFocus
    cmdEnterPassword.Default = True
    Exit Sub
  End If
  If cmdOperatorProgrammer.Caption = "Programmer" Then
    cmdOperatorProgrammer.Caption = "Operator"
    cmdAddFind.Visible = False
    cmdDelete.Visible = False
    cmdChangePassword.Visible = False
    txtBI1.Enabled = False
    txtBI2.Enabled = False
    txtBI3.Enabled = False
    txtPA1.Enabled = False
    txtPA2.Enabled = False
    txtPA3.Enabled = False
    txtCommand(0).Enabled = False
    txtCommand(1).Enabled = False
    txtTestInstructions.Locked = True
    lstTestIDs.Height = 2985
    Exit Sub
  End If
End Sub

Private Sub Form_Activate()
  If ChkProgStarted.value = 1 Then
    Exit Sub
  End If
  ChkProgStarted.value = 1
  Open "CommandsPos.ini" For Input As #2
  Line Input #2, DataBasePath$
  Close #2
  lstTestIDs.Clear
  datCommandsChk.DatabaseName = DataBasePath$
  datCommandsChk.Refresh
  datCommands.DatabaseName = DataBasePath$
  datCommands.Refresh
  datCommands.Recordset.MoveFirst
  Do While Not datCommands.Recordset.EOF
    lstTestIDs.AddItem (txtTestId.Text)
    datCommands.Recordset.MoveNext
    Index = Index + 1
  Loop
  Index = Index + 1
  datCommands.Refresh
  Open "CommandsParams.ini" For Input As #2
  Line Input #2, ThisLine
  txtBI1.Text = ThisLine
  Line Input #2, ThisLine
  txtBI2.Text = ThisLine
  Line Input #2, ThisLine
  txtBI3.Text = ThisLine
  Line Input #2, ThisLine
  txtPA1.Text = ThisLine
  Line Input #2, ThisLine
  txtPA2.Text = ThisLine
  Line Input #2, ThisLine
  txtPA3.Text = ThisLine
  Line Input #2, ThisLine
  txtPassword.Text = ThisLine
  Line Input #2, ThisLine
  chkCardInstalled.value = Int(ThisLine)
  Close #2
  If txtPassword.Text <> "000" Then
    cmdOperatorProgrammer.Caption = "Operator"
    cmdAddFind.Visible = False
    cmdDelete.Visible = False
    cmdChangePassword.Visible = False
    txtBI1.Enabled = False
    txtBI2.Enabled = False
    txtBI3.Enabled = False
    txtPA1.Enabled = False
    txtPA2.Enabled = False
    txtPA3.Enabled = False
    txtCommand(0).Enabled = False
    txtCommand(1).Enabled = False
    txtTestInstructions.Locked = True
    lstTestIDs.Height = 2985
  End If
End Sub
Private Sub WriteParams()
  Open "CommandsParams.ini" For Output As #2
  ThisLine = txtBI1.Text
  Print #2, ThisLine
  ThisLine = txtBI2.Text
  Print #2, ThisLine
  ThisLine = txtBI3.Text
  Print #2, ThisLine
  ThisLine = txtPA1.Text
  Print #2, ThisLine
  ThisLine = txtPA2.Text
  Print #2, ThisLine
  ThisLine = txtPA3.Text
  Print #2, ThisLine
  ThisLine = txtPassword.Text
  Print #2, ThisLine
  ThisLine = chkCardInstalled.value
  Print #2, ThisLine
  Close #2
End Sub

Private Function AddIbcnt() As String
  AddIbcnt = Chr$(13) + Chr$(10) + "ibcnt = 0x" + Hex$(ibcnt)
End Function

Private Function AddIberr() As String
  If (ibsta And EERR) Then
    If (iberr = EDVR) Then
      AddIberr = Chr$(13) + Chr$(10) + "iberr = EDVR <DOS Error>"
    End If
    If (iberr = ECIC) Then
      AddIberr = Chr$(13) + Chr$(10) + "iberr = ECIC <Not CIC>"
    End If
    If (iberr = ENOL) Then
      AddIberr = Chr$(13) + Chr$(10) + "iberr = ENOL <No Listener>"
    End If
    If (iberr = EADR) Then
      AddIberr = Chr$(13) + Chr$(10) + "iberr = EADR <Address Error>"
    End If
    If (iberr = EARG) Then
      AddIberr = Chr$(13) + Chr$(10) + "iberr = EARG <Invalid argument>"
    End If
    If (iberr = ESAC) Then
      AddIberr = Chr$(13) + Chr$(10) + "iberr = ESAC <Not Sys Ctrlr>"
    End If
    If (iberr = EABO) Then
       AddIberr = Chr$(13) + Chr$(10) + "iberr = EABO <Op. aborted>"
    End If
    If (iberr = ENEB) Then
      AddIberr = Chr$(13) + Chr$(10) + "iberr = ENEB <No GPIB board>"
    End If
    If (iberr = EOIP) Then
      AddIberr = Chr$(13) + Chr$(10) + "iberr = EOIP <Async I/O in prg>"
    End If
    If (iberr = ECAP) Then
      AddIberr = Chr$(13) + Chr$(10) + "iberr = ECAP <No capability>"
    End If
    If (iberr = EFSO) Then
      AddIberr = Chr$(13) + Chr$(10) + "iberr = EFSO <File sys. error>"
    End If
    If (iberr = EBUS) Then
      AddIberr = Chr$(13) + Chr$(10) + "iberr = EBUS <Command error>"
    End If
    If (iberr = ESTB) Then
      AddIberr = Chr$(13) + Chr$(10) + "iberr = ESTB <Status byte lost>"
    End If
    If (iberr = ESRQ) Then
      AddIberr = Chr$(13) + Chr$(10) + "iberr = ESRQ <SRQ stuck high>"
    End If
    If (iberr = ETAB) Then
      AddIberr = Chr$(13) + Chr$(10) + "iberr = ETAB <Table overflow>"
    End If
  Else
    AddIberr = Chr$(13) + Chr$(10) + "iberr = " + Str$(iberr)
  End If
End Function

Private Function AddIbsta() As String
  sta$ = Chr$(13) + Chr$(10) + "ibsta = &H" + Hex$(ibsta) + " <"
  If (ibsta And EERR) Then
    sta$ = sta$ + " ERR"
  End If
  If (ibsta And TIMO) Then
    sta$ = sta$ + " TIMO"
  End If
  If (ibsta And EEND) Then
    sta$ = sta$ + " END"
  End If
  If (ibsta And SRQI) Then
    sta$ = sta$ + " SRQI"
  End If
  If (ibsta And RQS) Then
    sta$ = sta$ + " RQS"
  End If
  If (ibsta And CMPL) Then
    sta$ = sta$ + " CMPL"
  End If
  If (ibsta And LOK) Then
    sta$ = sta$ + " LOK"
  End If
  
  If (ibsta And RREM) Then
    sta$ = sta$ + " REM"
  End If
  
  If (ibsta And CIC) Then
    sta$ = sta$ + " CIC"
  End If
  If (ibsta And AATN) Then
    sta$ = sta$ + " ATN"
  End If
  If (ibsta And TACS) Then
    sta$ = sta$ + " TACS"
  End If
  If (ibsta And LACS) Then
    sta$ = sta$ + " LACS"
  End If
  If (ibsta And DTAS) Then
    sta$ = sta$ + " DTAS"
  End If
  If (ibsta And DCAS) Then
    sta$ = sta$ + " DCAS"
  End If
  sta$ = sta$ + ">"
  AddIbsta = sta$
End Function

Private Sub ClearReadingsList()
  If ReadingsList.ListCount > 0 Then
    For i = 0 To ReadingsList.ListCount - 1
      ReadingsList.RemoveItem 0
    Next i
  End If
  ReadingsList.Refresh
End Sub

Private Sub GpibErr(msg$)
  msg$ = msg$ + AddIbsta() + AddIberr() + AddIbcnt()
  MsgBox msg$, vbOKOnly + vbExclamation, "Error"
  ilonl Dev, 0
End Sub

Private Sub ChkInt1_Click()
  If ChkInt1.value = 1 Then
    ChkInt2.value = 0
    ChkInt3.value = 0
  End If
End Sub

Private Sub ChkInt2_Click()
  If ChkInt2.value = 1 Then
    ChkInt1.value = 0
    ChkInt3.value = 0
  End If
End Sub
Private Sub ChkInt3_Click()
  If ChkInt3.value = 1 Then
    ChkInt2.value = 0
    ChkInt1.value = 0
  End If
End Sub

Private Sub Form_Load()
  GPIBglobalsRegistered = 0
  Call ClearReadingsList
End Sub

Private Sub Help_Click()
  Open "HelpModuleItem.ini" For Output As #2
  ThisModule = "*** Dielectric Test Guide ***"
  Print #2, ThisModule
  Close #2
  DielectricHelp.Show
End Sub

Private Sub lstTestIDs_Click()
  If ListIndex >= 0 Then
    ThisTest = lstTestIDs.List(lstTestIDs.ListIndex)
    If ThisTest <> "" Then
      SearchStr$ = ThisTest
      datCommands.Recordset.Index = "CmdID"
      datCommands.Recordset.Seek "=", SearchStr$
      If datCommands.Recordset.NoMatch Then
        response = MsgBox("Add New Record ?", vbYesNo, "Add New Record Yes/No")
        If Not response = vbYes Then
          Exit Sub
        End If
        datCommands.Recordset.AddNew
        txtTestId.Text = SearchStr$
        datCommands.Recordset.Index = "CmdID"
        datCommands.Recordset.Seek "=", SearchStr$
      End If
    End If
  End If
End Sub

Private Sub txtBI1_Validate(KeepFocus As Boolean)
  KeepFocus = False
  If Not IsNumeric(txtBI1.Text) Then
    KeepFocus = True
    MsgBox "Must be numeric", , "Error"
    Exit Sub
  End If
  WriteParams
End Sub

Private Sub txtBI2_Validate(KeepFocus As Boolean)
  KeepFocus = False
  If Not IsNumeric(txtBI2.Text) Then
    KeepFocus = True
    MsgBox "Must be numeric", , "Error"
    Exit Sub
  End If
  WriteParams
End Sub

Private Sub txtBI3_Validate(KeepFocus As Boolean)
  KeepFocus = False
  If Not IsNumeric(txtBI1.Text) Then
    KeepFocus = True
    MsgBox "Must be numeric", , "Error"
    Exit Sub
  End If
  WriteParams
End Sub

Private Sub txtPA1_Validate(KeepFocus As Boolean)
  KeepFocus = False
  If Not IsNumeric(txtPA1.Text) Then
    KeepFocus = True
    MsgBox "Must be numeric", , "Error"
    Exit Sub
  End If
  WriteParams
End Sub

Private Sub txtPA2_Validate(KeepFocus As Boolean)
  KeepFocus = False
  If Not IsNumeric(txtPA2.Text) Then
    KeepFocus = True
    MsgBox "Must be numeric", , "Error"
    Exit Sub
  End If
  WriteParams
End Sub

Private Sub txtPA3_Validate(KeepFocus As Boolean)
  If Not IsNumeric(txtPA3.Text) Then
    KeepFocus = True
    MsgBox "Must be numeric", , "Error"
    Exit Sub
  End If
  WriteParams
End Sub

Private Sub txtPassword_Click()
  txtPassword.Visible = False
  Label9.Visible = False
  WriteParams
End Sub


Private Sub txtPasswordEntry_CLICK()
  If txtPasswordEntry.Text <> txtPassword.Text Then
    txtPasswordEntry.Visible = False
    Label9.Visible = False
    Exit Sub
  End If
  txtPasswordEntry.Visible = False
  Label9.Visible = False
  cmdOperatorProgrammer.Caption = "Programmer"
  cmdAddFind.Visible = True
  cmdDelete.Visible = True
  cmdChangePassword.Visible = True
  txtBI1.Enabled = True
  txtBI2.Enabled = True
  txtBI3.Enabled = True
  txtPA1.Enabled = True
  txtPA2.Enabled = True
  txtPA3.Enabled = True
  txtCommand(0).Enabled = True
  txtCommand(1).Enabled = True
  txtTestInstructions.Locked = False
  lstTestIDs.Height = 2010
  txtPasswordEntry.Text = ""
  Exit Sub
End Sub
